package com.cndatacom.crypto;

import java.security.GeneralSecurityException;
import java.security.MessageDigest;

import javax.crypto.Mac;
import javax.crypto.spec.SecretKeySpec;

import android.text.TextUtils;

import com.cndatacom.utils.Strings;

public class Crypto 
{
	/**
	 * Base64
	 * @param s
	 * @return
	 */
	public static String encodeBase64(String s)
	{
		return new String(Crypt_Base64.encode(s.getBytes()));
	}
	
	/**
	 * Base64
	 * @param s
	 * @return
	 */
	public static String decodeBase64(String s)
	{
		return new String(Crypt_Base64.decode(s.getBytes()));
	}
	
	/**
	 * DES3ܴ
	 * @param sKey
	 * @param sIV
	 * @param sText
	 * @return
	 */
	public static String encodeDES3(String sKey, String sIV, String sText)
	{
		String results = "";
		if (!TextUtils.isEmpty(sText))
		{
			try 
			{
				byte[] key = Strings.hex2Bytes(sKey);
				byte[] siv = {1,2,3,4,5,6,7,8};
				if (!TextUtils.isEmpty(sIV))
				{
					siv = sIV.getBytes();
				}
				byte[] data = sText.getBytes();
				data = Crypt_Des3.des3EncodeCBC(key, siv, data);
				results = new String(Crypt_Base64.encode(data));
			} 
			catch (Exception ex) 
			{
				ex.printStackTrace();
			}
		}
		return results;
	}
	
	/**
	 * DES3ܴ
	 * @param sKey
	 * @param sIV
	 * @param sText
	 * @return
	 */
	public static String decodeDES3(String sKey, String sIV, String sText)
	{
		String results = "";
		if (!TextUtils.isEmpty(sText))
		{
			try 
			{
				byte[] key = Strings.hex2Bytes(sKey);
				byte[] siv = {1,2,3,4,5,6,7,8};
				if (!TextUtils.isEmpty(sIV))
				{
					siv = sIV.getBytes();
				}
				byte[] data = Crypt_Base64.decode(sText.getBytes());
				data = Crypt_Des3.des3DecodeCBC(key, siv, data);
				results = new String(data);
			} 
			catch (Exception ex) 
			{
				ex.printStackTrace();
			}
		}
		return results;
	}	
	
	/**
	 * SHA1ܴ
	 * @param testSrc
	 * @return
	 */
	public static byte[] encodeSHA1(byte[] testSrc)
	{
		try 
		{
			MessageDigest md = MessageDigest.getInstance("SHA-1");
			md.update(testSrc);
			return md.digest();
		} 
		catch (Exception ex)
		{
			ex.printStackTrace();
		}
		return null;
	}
	
	/**
	 * HMAC-SHA1ǩ
	 * @param data
	 * @param key
	 * @return
	 */
	public static String getHMACSHA1(byte[] data, byte[] key) 
	{
		SecretKeySpec signingKey = new SecretKeySpec(key, "HmacSHA1");
		Mac mac = null;
		try {
			mac = Mac.getInstance("HmacSHA1");
			mac.init(signingKey);
		} catch (GeneralSecurityException e) {
			throw new RuntimeException(e);
		}
		byte[] rawHmac = mac.doFinal(data);
		byte[] base64 = Crypt_Base64.encode(rawHmac);
		return new String(base64);
	}
	
	/**
	 * MD5
	 * @param source
	 * @return
	 */
	public static String getMD5(byte[] source)
	{
		String s = null;
		char hexDigits[] = {'0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f'};
		try
		{
			java.security.MessageDigest md = java.security.MessageDigest.getInstance( "MD5" );
		    md.update( source );
		    byte tmp[] = md.digest();
		    char str[] = new char[16 * 2];
		    int k = 0;
		    for (int i = 0; i < 16; i++) 
		    {
		    	byte byte0 = tmp[i];
		    	str[k++] = hexDigits[byte0 >>> 4 & 0xf];
		    	str[k++] = hexDigits[byte0 & 0xf];
		    }
		    s = new String(str);
		}
		catch(Exception ex)
		{
		    ex.printStackTrace();
		}
		return s;
	}
}
