package com.cndatacom.datas;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.text.TextUtils;

public class DBHelper extends SQLiteOpenHelper
{
	public DBHelper(Context context, String dbName, int dbVersion)
	{
		super(context, dbName, null, dbVersion);
	}

	@Override
	public void onCreate(SQLiteDatabase db)
	{
		String initSQL = getInitSQL();
		if (!TextUtils.isEmpty(initSQL))
		{
			db.execSQL(getInitSQL());
		}
	}

	@Override
	public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion)
	{
		String upgradeSQL = getUpgradeSQL();
		if (!TextUtils.isEmpty(upgradeSQL))
		{
			db.execSQL(upgradeSQL);
		}
	}
	
	private String getInitSQL()
	{
		StringBuffer sb = new StringBuffer();
		
		sb.append(" CREATE TABLE IF NOT EXISTS ");
		sb.append(" [Keys] ");
		sb.append("(");
		sb.append("[Id] INTEGER PRIMARY KEY AutoIncrement,");
		sb.append("[Key] VARCHAR(50),");
		sb.append("[Value] VARCHAR(255)");
		sb.append(");");
		sb.append("CREATE INDEX IDX_Keys_Key ON [Keys] (Key);");
		
		return sb.toString();
	}
	
	private String getUpgradeSQL()
	{
		StringBuffer sb = new StringBuffer();
		
		sb.append(" DROP TABLE IF EXISTS [Keys]; ");
		sb.append(" CREATE TABLE IF NOT EXISTS ");
		sb.append(" [Keys] ");
		sb.append("(");
		sb.append("[Id] INTEGER PRIMARY KEY AutoIncrement,");
		sb.append("[Key] VARCHAR(50),");
		sb.append("[Value] VARCHAR(255)");
		sb.append(");");
		sb.append("CREATE INDEX IDX_Keys_Key ON [Keys] (Key);");
		
		return sb.toString();
	}
}
