package com.cndatacom.datas;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;

import android.content.Context;
import android.content.res.Resources.NotFoundException;
import android.database.sqlite.SQLiteDatabase;
import android.os.Environment;
/**
 * ļ
 * @author WYT
 *
 */
public class DataHelper
{
    private Context _Context;
    /**
     * 캯
     * @param context : Ķ
     */
    public DataHelper(Context context)
    {  
        this._Context = context;
    }
    /**
     * ȡݿ
     * @param filename : ݿļ
     * @param rawId : ݿļԴID
     * @return ݿ
     */
    public SQLiteDatabase openDatabase(String filename, int rawId)
    {
    	SQLiteDatabase db = null;
        try
        {
        	String dbPath = getDataPath(this._Context, filename);
        	File dbFile = new File(dbPath);
            if(!dbFile.exists())
            {
            	initDatabase(this._Context, dbPath, rawId);
            }  
            db = SQLiteDatabase.openOrCreateDatabase(dbPath, null);
        } 
        catch (Exception ex)
        {
            ex.printStackTrace();  
        }
        return db;
    }
    /**
     * ȡļ·
     * @param context : Ķ
     * @param filename : ļ
     * @return ļ·
     */
    private String getDataPath(Context context, String filename)
    {
    	StringBuffer sbPath = new StringBuffer();
    	
    	sbPath.append("/");
    	sbPath.append("data");
    	sbPath.append(Environment.getDataDirectory().getAbsolutePath());
    	sbPath.append("/");
    	sbPath.append(context.getPackageName());
    	sbPath.append("/");
    	sbPath.append(filename);
    	
    	String dbPath = sbPath.toString();
    	
    	return dbPath;
    }
    /**
     * ʼݿ⣨ԴļĿ¼
     * @param context : Ķ
     * @param dbPath : ļ·
     * @param rawId : ԴļID
     */
    private void initDatabase(Context context, String dbPath, int rawId)
    {
    	try
    	{
        	InputStream reader = context.getResources().openRawResource(rawId);  
        	FileOutputStream writer = new FileOutputStream(dbPath);
	        byte[] buffer = new byte[512000];
	        int count = 0;
	        while((count = reader.read(buffer))>0)
	        {  
	        	writer.write(buffer , 0 , count);  
	        } 
	        writer.close();
	        reader.close();
    	} 
        catch (NotFoundException ex) 
        {
            ex.printStackTrace();  
        } 
        catch (FileNotFoundException ex)
        {
            ex.printStackTrace();  
        }
        catch (IOException ex) 
        {
            ex.printStackTrace(); 
        }
    }
}
