package com.cndatacom.datas;

import android.content.Context;
import android.content.SharedPreferences;

public class SharedHelper 
{
	private SharedPreferences _Shared;
	private SharedPreferences.Editor _Editor;
	private String _PathName = "CommonShared.xml";
	
	public SharedHelper(Context context) 
	{
		_Shared = context.getSharedPreferences(_PathName, 0);
		_Editor = _Shared.edit();
	}
    
	public SharedHelper(Context context, String pathName)
	{
		_PathName = pathName;
		_Shared = context.getSharedPreferences(_PathName, 0);
		_Editor = _Shared.edit();
	}
	
	public String getStrings(String key) 
	{
	   return  _Shared.getString(key, "");
	}	

	public void setStrings(String key, String value)
	{
		_Editor.putString(key, value);
		_Editor.commit();
	}
	
	public boolean getBooleans(String key) 
	{
		return _Shared.getBoolean(key, false);
	}
	
	public void setBooleans(String key, Boolean value)
	{
		_Editor.putBoolean(key, value);
		_Editor.commit();
	}
	
	public int getIntegers(String key) 
	{
		return _Shared.getInt(key, 0);
	}
	
	public void setIntegers(String key, int value)
	{
		_Editor.putInt(key, value);
		_Editor.commit();
	}
	
	public void removeKey(String key) 
	{
		_Editor.remove(key);
		_Editor.commit();
	}
	
	public void clearAll()
	{
		_Editor.clear();
		_Editor.commit();
	}
}
