package com.cndatacom.msgs;

import android.app.AlertDialog;
import android.app.Notification;
import android.app.NotificationManager;
import android.app.PendingIntent;
import android.app.ProgressDialog;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.os.Handler;
import android.os.Message;
import android.widget.Toast;

/**
 * ֪ͨ㲥Ϣ
 * @author WYT
 *
 */
public class Shows 
{
	/**
	 * ʾ
	 * @param context
	 * @param message
	 */
	public static void tips(Context context, String message) 
	{
		Toast toast = Toast.makeText(context, message, Toast.LENGTH_LONG);
		toast.show();
	}
	/**
	 * ʾȷϵ
	 * @param context
	 * @param sTitle
	 * @param sMessage
	 * @param listener
	 */
	public static void confirm(Context context, String sTitle, String sMessage, DialogInterface.OnClickListener listener){
		confirm(context, -1, sTitle, sMessage, listener);
	}
	/**
	 * ʾʾ
	 * @param context
	 * @param sTitle
	 * @param sMessage
	 */
	public static void alert(Context context, String sTitle, String sMessage){
		alert(context, -1, sTitle, sMessage);
	}
	/**
	 * ʾͼȷϵ
	 * @param context
	 * @param iconID
	 * @param sTitle
	 * @param sMessage
	 * @param listener
	 */
	public static void confirm(Context context, int iconID, String sTitle, String sMessage, DialogInterface.OnClickListener listener){
		AlertDialog.Builder dialog = new AlertDialog.Builder(context);
		if (iconID > -1) dialog.setIcon(iconID);
		dialog.setTitle(sTitle);
		dialog.setMessage(sMessage);
		dialog.setPositiveButton("ȷ", listener);
		dialog.setNegativeButton("ȡ", new DialogInterface.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialog, int which) { dialog.cancel(); }
		});
		dialog.create();
		dialog.show();
	}
	/**
	 * ʾͼʾ
	 * @param context
	 * @param iconID
	 * @param sTitle
	 * @param sMessage
	 */
	public static void alert(Context context, int iconID, String sTitle, String sMessage){
		AlertDialog.Builder dialog = new AlertDialog.Builder(context);
		if (iconID > -1) dialog.setIcon(iconID);
		dialog.setTitle(sTitle);
		dialog.setMessage(sMessage);
		dialog.setPositiveButton("ȷ", new DialogInterface.OnClickListener() {
			@Override
			public void onClick(DialogInterface dialog, int which) { dialog.cancel(); }
		});
		dialog.create();
		dialog.show();
	}
	/**
	 * 
	 * @param context
	 * @param tips
	 * @return
	 */
	public static ProgressDialog getProgress(Context context, String tips)
	{
		ProgressDialog dialog = new ProgressDialog(context);
		dialog.setMessage(tips);
		dialog.setCancelable(true);
		return dialog;
	}
	/** 
	 * ֪ͨ
	 * @param context
	 * @param intent֪ͨĿ¼Intent
	 * @param title: ֪ͨ
	 * @param content֪ͨ
	 * @param noticeID:֪ͨID
	 */
	public static void tipsNotice(Context context, Intent intent, String title, String content, int noticeID)
    {
        try
        {
        	NotificationManager noticer = (NotificationManager)context.getSystemService(Context.NOTIFICATION_SERVICE);

        	Notification notice = new Notification();
        	notice.defaults = Notification.DEFAULT_ALL;
        	notice.flags = Notification.FLAG_AUTO_CANCEL;
        	
        	PendingIntent contentIntent = PendingIntent.getActivity(context, 1, intent, PendingIntent.FLAG_UPDATE_CURRENT);
            notice.setLatestEventInfo(context, title, content, contentIntent);
            noticer.notify(1, notice);
        }
        catch (Exception ex)
        {
        	ex.printStackTrace();
        }
    }	
	/**
	 * ͹㲥
	 * @param context
	 * @param actionĿ㲥
	 * @param data
	 */
	public static void setBroadcasts(Context context, String action, String data)
    {
        try
        {
        	Intent intentBroadcast = new Intent(action);
            intentBroadcast.putExtra("DATA", data);
            context.sendBroadcast(intentBroadcast);
        }
        catch (Exception ex)
        {
        	ex.printStackTrace();
        }
    }
	/**
	 * HandlerϢ
	 * @param handler
	 * @param what
	 * @param data
	 */
	public static void setHandlers(Handler handler, int what, Object data){
		if (null != handler){
			Message message = new Message();
			message.what = 2;
			message.obj = data;
			handler.sendMessage(message);
		}
	}
	/**
	 * ʾͼ
	 * @param context
	 */
	public static void showNotice(Context context, Class<?> cls, int icon, String title, String content, int noticeID)
    {
		try
        {
			Intent notificationIntent = new Intent(context, cls);
			notificationIntent.setAction(Intent.ACTION_MAIN);
	        notificationIntent.addCategory(Intent.CATEGORY_LAUNCHER);
	        notificationIntent.addFlags(Intent.FLAG_ACTIVITY_NEW_TASK | Intent.FLAG_ACTIVITY_SINGLE_TOP);
	        
			PendingIntent contentIntent = PendingIntent.getActivity(context, 0, notificationIntent, PendingIntent.FLAG_UPDATE_CURRENT);
			
			Notification notice = new Notification(icon, title, System.currentTimeMillis());
			notice.flags = Notification.FLAG_ONGOING_EVENT;
	        notice.setLatestEventInfo(context, title, content, contentIntent);
	        	        
	        NotificationManager notificationManager = (NotificationManager)context.getSystemService(Context.NOTIFICATION_SERVICE);
	        notificationManager.notify(noticeID, notice);
        }
        catch (Exception ex)
        {
            ex.printStackTrace();
        }
    }
	/**
	 * ͼ
	 * @param context
	 */
    public static void hideNotice(Context context, int noticeID)
    {
    	try
        {
    		NotificationManager notificationManager = (NotificationManager)context.getSystemService(Context.NOTIFICATION_SERVICE);
    		notificationManager.cancel(noticeID);
	    }
	    catch (Exception ex)
	    {
	    	ex.printStackTrace();
	    }
    }
}
