package com.cndatacom.network;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;

public class FileInfo 
{
	private byte[] data; 
	private InputStream inStream; 
	private File file;
	private String filname;
	private String parameterName;
	private String contentType = "application/octet-stream";

	public FileInfo(String filname, byte[] data, String parameterName, String contentType) 
	{ 
		this.data = data; 
		this.filname = filname; 
		this.parameterName = parameterName; 
		if(contentType!=null) this.contentType = contentType; 
	} 


	public FileInfo(String filname, File file, String parameterName, String contentType) { 
		this.filname = filname; 
		this.parameterName = parameterName; 
		this.file = file; 
		try { 
			this.inStream = new FileInputStream(file); 
		} catch (FileNotFoundException e) { 
			e.printStackTrace(); 
		} 
		if(contentType!=null) this.contentType = contentType; 
	} 

	public File getFile() { return file; }

	public InputStream getInStream() { return inStream; }

	public byte[] getData() { return data; }

	public String getFilname() { return filname; } 
	public void setFilname(String v) { filname = v; } 

	public String getParameterName() { return parameterName; } 
	public void setParameterName(String v) { parameterName = v; } 

	public String getContentType() { return contentType; } 
	public void setContentType(String v) { contentType = v; }  
}
