package com.cndatacom.network;

import java.io.ByteArrayOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.URL;

import android.os.Handler;
import android.os.Message;

public class Nets implements Runnable {
	
	private String requestURL;
	private Handler handler;
	private String requestData;

	public Nets(String requestURL, String requestData, Handler handler){
		this.requestURL = requestURL;
		this.requestData = requestData;
		this.handler = handler;
	}

	@Override
	public void run() {		
		Message msg = new Message();
		HttpURLConnection conn = null;
		OutputStream outStream = null;
		InputStream inStream = null;
		try {
			
			URL url = new URL(this.requestURL);
			conn = (HttpURLConnection)url.openConnection();
			conn.setReadTimeout(50 * 1000);
			conn.setDoInput(true);
			conn.setDoOutput(true);
			conn.setRequestMethod("POST");
			conn.setRequestProperty("Accept", "application/soap+xml");
			conn.setRequestProperty("Content-Type", "text/xml");
			conn.setRequestProperty("User-Agent",	"android");
			conn.setRequestProperty("Charset", "utf-8");
			if (this.requestData != null) {
				outStream = conn.getOutputStream();
				outStream.write(this.requestData.getBytes("UTF-8"));
				outStream.flush();
				outStream.close();
			}
			
			int readCode = conn.getResponseCode();
			if (readCode >= 200 && readCode < 300) {
				int max_content_length = 10240;
				int len = conn.getContentLength();
				if (len > 0 && len <= max_content_length) {
					byte[] result = new byte[len];
					inStream = conn.getInputStream();
					int n, i = 0;
					while ((n = inStream.read(result,i,len - i)) != -1) {
						i += n;
					}
					inStream.close();
					msg.what = 500;
					msg.obj = new String(result);
				} else {
					msg.what = 500;
					msg.obj = ":ݳȳ.";
				}
			} else {
				msg.what = 500;
				msg.obj = ":CODE=" + readCode;
			}
			conn.disconnect();			
		} 
		catch (Exception ex)
		{
			msg.what = 500;
			msg.obj = ex.getMessage();
		} 
		finally
		{
			handler.sendMessage(msg);
		}
	}
	
	public String inputStreamtoString(InputStream in) throws IOException
	{		
		ByteArrayOutputStream  out = new ByteArrayOutputStream();
		byte[] b = new byte[4096];
		for (int n; (n = in.read(b)) != -1;) {
			out.write(b, 0, n);   
		}		
		return new String(out.toByteArray(), "utf-8");		
	}
}
