package com.cndatacom.network;

import java.net.InetAddress;
import java.net.InetSocketAddress;
import java.net.NetworkInterface;
import java.net.Proxy;
import java.net.SocketAddress;
import java.util.Enumeration;

import com.cndatacom.utils.Strings;

import android.content.Context;
import android.net.ConnectivityManager;
import android.net.NetworkInfo;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.telephony.TelephonyManager;
import android.text.TextUtils;

public class Utils
{
	public static Proxy getProxy(Context context)
	{
		Proxy returnValue = null;
		
		try
		{
			NetworkInfo networkInfo = ((ConnectivityManager) context.getSystemService(Context.CONNECTIVITY_SERVICE)).getActiveNetworkInfo();
		    if (networkInfo.getType() == ConnectivityManager.TYPE_MOBILE)
		    {
		    	String host = android.net.Proxy.getDefaultHost();
		    	if (!TextUtils.isEmpty(host))
		    	{
			    	int port = android.net.Proxy.getDefaultPort();

			    	InetAddress address = InetAddress.getByName(host);
			    	SocketAddress sa = new InetSocketAddress(address, port);
				    returnValue = new Proxy(java.net.Proxy.Type.HTTP, sa);
		    	}
		    }
		}
		catch(Exception ex)
		{
			ex.printStackTrace();
		}
		
		return returnValue;
	}
	
	/**
	 * Ƿ
	 */
	public static boolean hasNetwork(Context context)
	{
		Boolean results = false;
		ConnectivityManager conn = (ConnectivityManager)context.getSystemService(Context.CONNECTIVITY_SERVICE);
		NetworkInfo network = conn.getActiveNetworkInfo();
		if (null != network && network.isConnected())
		{
			results = true;
		}
		return results;
	}
	
	/**
	 * ȡ
	 * @param activity : Activityʵ
	 * @return 
	 */
	public static String getNetworkType(Context context)
	{
	    String results = "No Service";
	    
	    ConnectivityManager CM = (ConnectivityManager)context.getSystemService(Context.CONNECTIVITY_SERVICE);
	    NetworkInfo network = CM.getActiveNetworkInfo();
	   
	    if (null != network) 
	    {
	    	int type = network.getType();
	    	if (ConnectivityManager.TYPE_MOBILE == type)
	    	{
	    		results = "Mobile";
		        TelephonyManager TM = (TelephonyManager)context.getSystemService(Context.TELEPHONY_SERVICE);
		        if (TelephonyManager.NETWORK_TYPE_UMTS == TM.getNetworkType()) {
		        	results = "3G";
		        } else if (TelephonyManager.NETWORK_TYPE_EDGE == TM.getNetworkType()) {
		        	results ="EDGE";
		        }
		    }
	    	else if (ConnectivityManager.TYPE_WIFI == type)
		    {		      
		        WifiManager wm = (WifiManager)context.getSystemService(Context.WIFI_SERVICE);
		        WifiInfo wi = wm.getConnectionInfo();
		        int wifiSignalStrength = WifiManager.calculateSignalLevel(wi.getRssi(), 4);
		        results = wi.getSSID() + " " + wifiSignalStrength + " " + "bars";
		    }
		}
	    
	    return results;
	}
	
	/**
	 * ȡֻIPַ
	 * @param context
	 * @return
	 */
	public static String getPhoneIpAddress(Context context) 
	{
		String ip = "";
		try 
		{
			WifiManager wifi = (WifiManager)context.getSystemService(Context.WIFI_SERVICE);
			if (wifi.isWifiEnabled()) 
			{ 
				//WIFI
				WifiInfo wifiInfo = wifi.getConnectionInfo();
				int ipAddress = wifiInfo.getIpAddress();
				ip = Strings.getIP(ipAddress);
				return ip;				
			} 
			else
			{ 
				//3G
				for (Enumeration<NetworkInterface> en = NetworkInterface.getNetworkInterfaces(); en.hasMoreElements();) {
					NetworkInterface intf = en.nextElement();
					for (Enumeration<InetAddress> enumIpAddr = intf.getInetAddresses(); enumIpAddr.hasMoreElements();) {
						InetAddress inetAddress = enumIpAddr.nextElement();
						if (!inetAddress.isLoopbackAddress()) {
							return inetAddress.getHostAddress();
						}
					}
				}
			}
		} 
		catch (Exception e)
		{
			e.printStackTrace();
		}
		return ip;
	}
}
