package com.cndatacom.trees;

import java.util.List;

import android.content.Context;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.RelativeLayout;
import android.widget.RelativeLayout.LayoutParams;
import android.widget.TextView;

public class Treeview
{
	public void showTree(Context context, LinearLayout linear, List<Treeentity> list)
	{
		linear.removeAllViews();
		for(Treeentity item : list)
		{
			RelativeLayout layout = new RelativeLayout(context);			
			LayoutParams params = new LayoutParams(LayoutParams.FILL_PARENT, LayoutParams.WRAP_CONTENT);
			layout.setLayoutParams(params);
			
			LayoutParams pICO = new LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
			pICO.addRule(RelativeLayout.ALIGN_PARENT_LEFT);
			ImageView ico = new ImageView(context);
			ico.setLayoutParams(pICO);
			ico.setId(0);
			layout.addView(ico);
			
			LayoutParams pTitle = new LayoutParams(LayoutParams.WRAP_CONTENT, LayoutParams.WRAP_CONTENT);
			pTitle.addRule(RelativeLayout.RIGHT_OF, ico.getId());
			TextView title = new TextView(context);
			title.setLayoutParams(pTitle);
			title.setText(item.getTitle());
			layout.addView(title);
			
			linear.addView(layout);
		}
	}
	
	public class Treeentity 
	{
		private int iLevel;
		private String sID;
		private String sICO;
		private String sTitle;
		
		public int getLevel(){ return iLevel; }
		public void setLevel(int v){ iLevel = v; }
		
		public String getID(){ return sID; }
		public void setID(String v){ sID = v; }
		
		public String getICO(){ return sICO; }
		public void setICO(String v){ sICO = v; }
		
		public String getTitle(){ return sTitle; }
		public void setTitle(String v){ sTitle = v; }
	}
}

