package com.cndatacom.utils;

import java.io.UnsupportedEncodingException;

import org.json.JSONException;
import org.json.JSONObject;

import android.text.TextUtils;
import android.util.Log;

public class Strings 
{    
    /**
	 * תbyte4
	 * @param i
	 * @return
	 */
	public static byte[] intToByte4(int i) {  
		byte[] targets = new byte[4];  
        targets[0] = (byte) (i & 0xFF);  
        targets[1] = (byte) (i >> 8 & 0xFF);
        targets[2] = (byte) (i >> 16 & 0xFF);
        targets[3] = (byte) (i >> 24 & 0xFF);
        return targets;
    }
	/**
	 * byteת
	 * @param i
	 * @return
	 */
	public static int byteToInt(byte i) {
		return i >= 0 ? (int)i : ((int)(i & 0x7f) | 0x80);
    }
	/**
	 * byte[4]ת
	 * @param i
	 * @return
	 */
	public static int byte4ToInt(byte[] b, int off) { 
		int targets = byteToInt(b[off]);
		targets	|= (byteToInt(b[off+1]) << 8);
		targets	|= (byteToInt(b[off+2]) << 16);
		targets	|= (byteToInt(b[off+3]) << 24);
        return targets;
	}
	/**
	 * ַʽΪָ
	 * @param string : Ҫʽַ
	 * @param lens : ָ׼
	 * @param padChar : ַ
	 * @return
	 */
	public static String pads(String string, int lens, String padChar)
	{
		while (string.length() < lens){
			string = padChar + string;
		}
		return string;
	}
	
	public static JSONObject stringToJson(String sJson) 
	{
		JSONObject json = null;
		try
		{
			json = new JSONObject(sJson);
		} 
		catch(JSONException ex)
		{
			Log.e("getJson JSONException:", ex.getMessage());
		}
		return json;
	}
	
	public static String sqlSList(String params)
	{
		StringBuffer s = new StringBuffer();
		
		String Lists[] = params.split(",");
		for(int i = 0; i < Lists.length; i++)
		{
			if (i > 0)
			{
				s.append(",");
			}
			s.append("'" + sqlClean(Lists[0]) + "'");
		}
		
		return s.toString();
	}
	
	public static String sqlClean(String params)
	{
		return (null == params) ? params : params.replace("'", "");
	}
		
	/**
	 * ʮַתbyte
	 * @param s : ʮַ
	 * @return byte[]
	 */
	public static byte[] hex2Bytes(String s)
	{
		byte[] buffer = new byte[s.length() / 2];
		for (int i = 0; i < buffer.length; i++)
		{
			int t1 = i * 2;
			int t2 = t1 + 1;
			int t3 = t1 + 2;
			String s1 = s.substring(t1, t2);
			String s2 = s.substring(t2, t3);
			buffer[i] = (byte)(char2Hex(s1) * 0x10 + char2Hex(s2));
		}
		return buffer;
	} 
	   
	/**
	 * ʮַתbyte
	 * @param chr
	 * @return byte
	 */
	private static byte char2Hex(String chr)
	{
		if (chr.equals("0")) {
			return 0x00;
		} else if (chr.equals("1")) {
			return 0x01;
		} else if (chr.equals("2")) {
			return 0x02;
		} else if (chr.equals("3")) {
			return 0x03;
		} else if (chr.equals("4")) {
			return 0x04;
		} else if (chr.equals("5")) {
			return 0x05;
		} else if (chr.equals("6")) {
			return 0x06;
		} else if (chr.equals("7")) {
			return 0x07;
		} else if (chr.equals("8")) {
			return 0x08;
		} else if (chr.equals("9")) {
			return 0x09;
		} else if (chr.equals("A")) {
			return 0x0a;
		} else if (chr.equals("B")) {
			return 0x0b;
		} else if (chr.equals("C")) {
			return 0x0c;
		} else if (chr.equals("D")) {
			return 0x0d;
		} else if (chr.equals("E")) {
			return 0x0e;
		} else if (chr.equals("F")) {
			return 0x0f;
		}
		return 0x00;
	}	  
		
	/**
	 * ַתbyte
	 * @param s
	 * @return
	 */
	public static byte[] string2Bytes(String s) 
	{
		byte[] buffer = null;
		try
		{
			if (!TextUtils.isEmpty(s)) 
			{
				buffer = s.getBytes("utf-8");
			}
		} 
		catch(UnsupportedEncodingException ex)
		{
			ex.printStackTrace();
		}
		return buffer;
	}
	
	/**
	 * ȡIPV4ַ
	 * @param ipAddress : IP
	 * @return
	 */
	public static String getIP(int ipAddress)
	{
		StringBuffer sb = new StringBuffer();
		
		sb.append(ipAddress & 0xFF);
		sb.append(".");
		sb.append((ipAddress >> 8)  & 0xFF);
		sb.append(".");
		sb.append((ipAddress >> 16) & 0xFF);
		sb.append(".");
		sb.append((ipAddress >> 24) & 0xFF);
		
		return sb.toString();
	}
	/**
	 * жǷַ
	 * @param s
	 * @return
	 */
	public static boolean isEmpty(String s) {
		return s == null || s.equals("");
	}
}
