package com.cndatacom.utils;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import android.app.Activity;
import android.app.ActivityManager;
import android.content.Context;
import android.net.ConnectivityManager;
import android.net.DhcpInfo;
import android.net.NetworkInfo;
import android.net.wifi.WifiInfo;
import android.net.wifi.WifiManager;
import android.telephony.TelephonyManager;
import android.text.format.Formatter;
import android.util.DisplayMetrics;

public class Tools 
{
	/**
	 * 
	 * @param activity
	 */
	protected void doOtherAction(Activity activity)
    {
    	try
    	{
	        Context context = activity.createPackageContext("packageName", Context.CONTEXT_INCLUDE_CODE | Context.CONTEXT_IGNORE_SECURITY);
	        Class<?> clazz = context.getClassLoader().loadClass("classFullName");
	        Object instance = clazz.newInstance();
	        clazz.getMethod("mothodName", String.class).invoke(instance, "Params");
    	}
    	catch(Exception ex)
    	{
    		ex.printStackTrace();
    	}
    }
	/**
	 * ȡĻߴ
	 * @param activity
	 * @return
	 */
	public static int ScreenWidth(Activity activity)
	{
		DisplayMetrics dm = new DisplayMetrics();
		activity.getWindowManager().getDefaultDisplay().getMetrics(dm);
		return dm.widthPixels;
	}
	/**
	 * ȡĻߴ
	 * @param activity
	 * @return
	 */
	public static int ScreenHeight(Activity activity)
	{
		DisplayMetrics dm = new DisplayMetrics();
		activity.getWindowManager().getDefaultDisplay().getMetrics(dm);
		return dm.heightPixels;
	}
	/**
	 * ȡֻϢ
	 * @param context : ǰ
	 * @return Map<String, String>
	 */
	public static Map<String, String> getPhoneInFormation(Context context)
	{
		Map<String, String> phoneinfo = new HashMap<String, String>();
		TelephonyManager TM = (TelephonyManager) context.getSystemService(Context.TELEPHONY_SERVICE);
		phoneinfo.put("DeviceId", TM.getDeviceId());
		phoneinfo.put("PhoneNum", TM.getLine1Number());
		phoneinfo.put("IMEI_Num", TM.getSimSerialNumber());
		return phoneinfo;
	}
	
	/**
	 * ӦƵķǷѾ
	 * @param context : ǰ
	 * @param className : Ҫķ
	 * @return true : , false : δ
	 */
	public static boolean isServiceRunning(Context context, String className)
	{
		boolean isRunning = false;

		ActivityManager AM = (ActivityManager) context.getSystemService(Context.ACTIVITY_SERVICE);

		List<ActivityManager.RunningServiceInfo> services = AM.getRunningServices(Integer.MAX_VALUE);

		for(ActivityManager.RunningServiceInfo info : services)
		{
			String serviceName = info.service.getClassName();						
			if (serviceName.equals(className))
			{
				isRunning = true;
				break;
			}
		}
		
		return isRunning;
	}		
	/**
	 * ȡIP
	 * @param ctx
	 * @return
	 */
	public static String getIPAddress(Context ctx){
		return getIPAddress(ctx, "ipaddress");
	}
	/**
	 * ȡ
	 * @param ctx
	 * @return
	 */
	public static String getGateway(Context ctx){
		return getIPAddress(ctx, "gateway");
	}
	/**
	 * ȡ
	 * @param ctx
	 * @return
	 */
	public static String getNetmask(Context ctx){
		return getIPAddress(ctx, "netmask");
	}
	/**
	 * ȡMAC
	 * @param ctx
	 * @return
	 */
	public static String getMacAddress(Context ctx){
		String results = null;
		WifiInfo wifi = getConnectWifiInfo(ctx);
		if (null != wifi){
			results = wifi.getMacAddress();
		}
		return results;
	}	
	/**
	 * ȡIPϢ
	 * @param ctx
	 * @return
	 */
	private static String getIPAddress(Context ctx, String type){
		WifiManager wifi_service = (WifiManager) ctx.getSystemService(Context.WIFI_SERVICE);
		DhcpInfo dhcpInfo = wifi_service.getDhcpInfo();
		//WifiInfo wifiinfo = wifi_service.getConnectionInfo();
		//System.out.println("Wifi info        ----->"+wifiinfo.getIpAddress());
		//System.out.println("DHCP info gateway----->"+Formatter.formatIpAddress(dhcpInfo.gateway));
		//System.out.println("DHCP info netmask----->"+Formatter.formatIpAddress(dhcpInfo.netmask));
		if (type == "gateway"){
			return Formatter.formatIpAddress(dhcpInfo.gateway);
		} if (type == "netmask"){
			return Formatter.formatIpAddress(dhcpInfo.netmask);
		} else {
			return Formatter.formatIpAddress(dhcpInfo.ipAddress);
		}
	}
	/**
	 * ȡǰWIFIϢ
	 * @param context : Contextʵ
	 * @return ǰWIFIϢ
	 */
	public static WifiInfo getConnectWifiInfo(Context context)
	{
		WifiInfo results = null;	    
	    ConnectivityManager CM = (ConnectivityManager)context.getSystemService(Context.CONNECTIVITY_SERVICE);
	    NetworkInfo network = CM.getActiveNetworkInfo();
	    if (null != network) 
	    {
	    	int type = network.getType();
	    	if (ConnectivityManager.TYPE_WIFI == type)
		    {		      
		        WifiManager wm = (WifiManager)context.getSystemService(Context.WIFI_SERVICE);
		        results = wm.getConnectionInfo();
		    }
		}	    
	    return results;
	}
}
