package com.cndatacom.webUtils;

import android.app.Activity;
import android.graphics.Bitmap;
import android.os.Handler;
import android.os.Message;
import android.view.View;
import android.view.Window;
import android.webkit.JsResult;
import android.webkit.WebChromeClient;
import android.webkit.WebSettings;
import android.webkit.WebView;
import android.webkit.WebViewClient;

public class Weber 
{		
	/**
	 * ʼWebViewؼ
	 * @param activity: Activity
	 * @param webview: WebView
	 * @param handler: Handler
	 */
	public static void initWebView(final Activity activity, final WebView webview, final Handler handler) 
	{
		WebSettings webSettings = webview.getSettings();
		webSettings.setSaveFormData(true);
		webSettings.setJavaScriptEnabled(true);
		JSInterface jsInterface = new JSInterface(activity, webview, handler);
		webview.addJavascriptInterface(jsInterface, "androidJs");
		webview.setScrollBarStyle(View.SCROLLBARS_INSIDE_OVERLAY);
		webview.clearCache(true);
		webview.requestFocus();
		webview.setWebViewClient(new WebClient(handler));
		webview.setWebChromeClient(new WebChromeClient() 
		{
			@Override
			public void onProgressChanged(WebView view, int newProgress) 
			{
				activity.getWindow().setFeatureInt(Window.FEATURE_PROGRESS, newProgress * 100);
				if(newProgress == 100) {
					Message message = new Message();
					message.what = 0; 
					handler.sendMessage(message);
				}
				super.onProgressChanged(view, newProgress);
			}

			@Override
			public boolean onJsAlert(WebView view, String url, String message, JsResult result)
			{
				return super.onJsAlert(view, url, message, result);
			}

			@Override
			public void onReceivedTitle(WebView view, String title)
			{
				activity.setTitle(title);
				super.onReceivedTitle(view, title);
			}
		});
	}
	
	/**
	 * ַ
	 * @param webView ؼ
	 * @param sUrl ַ
	 */
	public static void loadUrl(WebView webview, String sUrl){		
		webview.loadUrl(sUrl);
	}
	
	/**
	 * رļ
	 * @param webView ؼ
	 * @param sPath ļ·
	 */
	public static void loadFile(WebView webview, String sPath){		
		webview.loadUrl("file:///android_asset/" + sPath);
	}
	
	/**
	 * ҳı
	 * @param webView ؼ
	 * @param sHTML ҳı
	 */
	public static void loadHTML(WebView webview, String sHTML){		
		webview.loadData(sHTML, "text/html", "utf-8");
	}
	/**
	 * ҳı
	 * @param webView ؼ
	 * @param sHTML ҳı
	 */
	public static void loadHTML(WebView webview, String sHTML, String sEncoding){		
		webview.loadData(sHTML, "text/html", sEncoding);
	}
}

class WebClient extends WebViewClient
{
	Handler handler;

	public WebClient(Handler handler)
	{
		this.handler = handler;
	}

	@Override
	public void onPageStarted(WebView view, String url, Bitmap favicon)
	{
		super.onPageStarted(view, url, favicon);
	}

	@Override
	public void onPageFinished(WebView view, String url)
	{
		super.onPageFinished(view, url);
		view.requestFocus();
		view.requestFocusFromTouch();
		Message message = new Message();
		message.what = 0;
		handler.sendMessage(message);		
	}
}